unit wamptd;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, AppEvent, RXShell, IniFiles, ComCtrls, Menus,
  RxGrdCpt;

type
  TfrmMain = class(TForm)
    eFilename: TEdit;
    ePrefix: TEdit;
    lPrefix: TLabel;
    eSuffix: TEdit;
    lSuffix: TLabel;
    eNothing: TEdit;
    lNone: TLabel;
    lblFilename: TLabel;
    btnSave: TButton;
    btnCancel: TButton;
    tmrWampDescriptor: TTimer;
    cbKillOnExit: TCheckBox;
    cbKillOnNothing: TCheckBox;
    aeWampDescriptor: TAppEvents;
    tiWampDescriptor: TRxTrayIcon;
    btnExit: TButton;
    sbMain: TStatusBar;
    tbRefresh: TTrackBar;
    lblRefreshtime: TLabel;
    pmTray: TPopupMenu;
    Showsettings1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    gcMain: TRxGradientCaption;
    procedure tmrWampDescriptorTimer(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
    procedure tiWampDescriptorDblClick(Sender: TObject);
    procedure aeWampDescriptorActivate(Sender: TObject);
    procedure btnExitClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure tbRefreshChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Showsettings1Click(Sender: TObject);
    procedure tiWampDescriptorClick(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Exit1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;
  np_str: string;
  IniFile: TIniFile;

implementation

{$R *.DFM}

procedure TfrmMain.tmrWampDescriptorTimer(Sender: TObject);
var
 Handle : THandle;
 Title : array [0..255] of Char;
 np: string;
 f: system.text;
 count : integer;
begin
 Handle := FindWindow('Winamp v1.x', nil);
 if Handle=0 then np:='' else
   begin
     GetWindowText(Handle, Title, 255);
     np := StrPas(Title);
     if (Copy(np, 1, 6) = 'Winamp') or (np[length(np)]=']') or (pos('.',np) = 0) then np:=''
     else
       begin
         np := Copy(np, pos('.',np)+2,length(np)-12);
         for count:=1 to length(np) do
         case np[count] of
                    #205: np[count]:='H';
                    #240: np[count]:='p';
           end;
       end;
   end;
 if np='' then np := IniFile.ReadString('Main','Prefix','np:')+#32+IniFile.ReadString('Main','Nothing','nothing') else
 np := IniFile.ReadString('Main','Prefix','np:')+#32+np+#32+IniFile.ReadString('Main','Suffix','');
 for count:=1 to Length(np) do
 sbMain.SimpleText := np;
 if (IniFile.ReadBool('Main','KillOnNothing',false)
     and
    (np=IniFile.ReadString('Main','Prefix','np:')+#32+IniFile.ReadString('Main','Nothing','nothing')))
   then
     begin
       if FileExists(IniFile.ReadString('Main','Filename','c:\fido\golded\np.wa')) then
        if not (np = np_str) then
         begin
          AssignFile(f,IniFile.ReadString('Main','Filename','c:\fido\golded\np.wa'));
          Erase(f);
          np_str := np;
         end;
     end
   else
    if not (np = np_str) then
     begin
       AssignFile(f,IniFile.ReadString('Main','Filename','c:\fido\golded\np.wa'));
       Rewrite(f);
       AnsiToOemBuff(@np[1], @np[1], Length(np));
       Write(f,np);
       CloseFile(f);
       np_str := np;
     end;
end;

procedure TfrmMain.btnCancelClick(Sender: TObject);
begin
 Application.Minimize;
 ShowWindow(Application.Handle, SW_HIDE);
 eFileName.Text := IniFile.ReadString('Main','Filename','c:\fido\golded\np.wa');
 ePrefix.Text := IniFile.ReadString('Main','Prefix','np:');
 eSuffix.Text := IniFile.ReadString('Main','Suffix','');
 eNothing.Text := IniFile.ReadString('Main','Nothing','nothing');
 cbKillOnExit.Checked := IniFile.ReadBool('Main','KillOnExit',false);
 cbKillOnNothing.Checked := IniFile.ReadBool('Main','KillOnNothing',false);
 lblRefreshtime.Caption := 'Refresh time:'+#32+IniFile.ReadString('Main','Refreshtime','50')+#32+'ms';
 tbRefresh.Position := IniFile.ReadInteger('Main','Refreshtime',50);
end;

procedure TfrmMain.btnSaveClick(Sender: TObject);
begin
 tmrWampDescriptor.Enabled := false;
 IniFile.WriteString('Main','FileName',eFileName.Text);
 IniFile.WriteString('Main','Prefix',ePrefix.Text);
 IniFile.WriteString('Main','Suffix',eSuffix.Text);
 IniFile.WriteString('Main','Nothing',eNothing.Text);
 IniFile.WriteBool('Main','KillOnExit',cbKillOnExit.Checked);
 IniFile.WriteBool('Main','KillOnNothing',cbKillOnNothing.Checked);
 IniFile.WriteInteger('Main','RefreshTime',tbRefresh.Position);
 tmrWampDescriptor.Enabled := true;
end;

procedure TfrmMain.tiWampDescriptorDblClick(Sender: TObject);
begin
 Application.Restore;
end;

procedure TfrmMain.aeWampDescriptorActivate(Sender: TObject);
begin
 ShowWindow(Application.Handle, SW_HIDE);
end;

procedure TfrmMain.btnExitClick(Sender: TObject);
begin
 frmMain.Close;
end;

procedure TfrmMain.FormShow(Sender: TObject);
begin
 ShowWindow(Application.Handle, SW_HIDE);
 eFileName.Text := IniFile.ReadString('Main','Filename','c:\fido\golded\np.wa');
 ePrefix.Text := IniFile.ReadString('Main','Prefix','np:');
 eSuffix.Text := IniFile.ReadString('Main','Suffix','');
 eNothing.Text := IniFile.ReadString('Main','Nothing','nothing');
 cbKillOnExit.Checked := IniFile.ReadBool('Main','KillOnExit',false);
 cbKillOnNothing.Checked := IniFile.ReadBool('Main','KillOnNothing',false);
 lblRefreshtime.Caption := 'Refresh time:'+#32+IniFile.ReadString('Main','Refreshtime','50')+#32+'ms';
 tbRefresh.Position := IniFile.ReadInteger('Main','Refreshtime',50);
end;

procedure TfrmMain.tbRefreshChange(Sender: TObject);
begin
 lblRefreshtime.Caption := 'Refresh time:'+#32+IntToStr(tbRefresh.Position)+#32+'ms';
 tiWampDescriptor.Interval := tbRefresh.Position;
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
var
 f: system.text;
begin
 tmrWampDescriptor.Enabled := false;
 if (FileExists(IniFile.ReadString('Main','Filename','c:\fido\golded\np.wa')) and IniFile.ReadBool('Main','KillOnExit',false)) then
   begin
     AssignFile(f,IniFile.ReadString('Main','Filename','c:\fido\golded\np.wa'));
     Erase(f);
   end;
 IniFile.Free; 
end;

procedure TfrmMain.Showsettings1Click(Sender: TObject);
begin
 Application.Restore;
end;

procedure TfrmMain.tiWampDescriptorClick(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 if button=mbRight then pmTray.Popup(x,y);
end;

procedure TfrmMain.Exit1Click(Sender: TObject);
begin
  btnExit.Click;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
 IniFile := TIniFile.Create(ExtractFilePath(paramstr(0))+'winampd.ini');
end;

end.
